<?php
/**
 * (c) 2004-2006 Linbox / Free&ALter Soft, http://linbox.com
 *
 * $Id: render.php 24 2006-06-08 13:01:17Z jwax $
 *
 * This file is part of LMC.
 *
 * LMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * LMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with LMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>
<?

require("modules/printstats/includes/xmlrpc.php");
require("modules/printstats/includes/libchart/libchart.php");

ob_end_clean();

$type = $_GET["type"];
$days = $_GET["days"];

if ($type == "history") {
    $chart = new VerticalChart(750, 300);
    if ($days == 365) {
        /* Draw a 12 bars chart, one bar by month */
        $data = getHistoryByMonths($_SESSION["printserver"], intval($days));
        $d = getdate();
        $cyear = $d["year"] - 1;
        $cmonth = $d["mon"] + 1;
        if ($cmonth == 13) {
            $cmonth = 1;
            $cyear ++;
        }
        for($i = 0; $i < 12; $i ++) {
            $cdate = sprintf("%02d-%d", $cmonth, $cyear);
            $found = False;
            foreach($data as $idx => $tuple) {
                $date = sprintf("%02d-%d", $tuple[1], $tuple[2]);
                if ($date == $cdate) {
                    $chart->addPoint(new Point($date,$tuple[0]));
                    $found = True;
                    break;
                }
            }
            if (!$found) $chart->addPoint(new Point($cdate, 0));
            $cmonth ++;
            if ($cmonth == 13) {
                $cmonth = 1;
                $cyear ++;
            }
        }
    } else {
        $data = getHistory($_SESSION["printserver"], intval($days));

        $t = time();
        for($i = $days; $i > 0; $i--) {
            $t = time() - 60 * 60 * 24 * $i;
            $found = False;
            $cdate = strftime("%d-%m-%Y", $t);
            foreach($data as $idx => $tuple) {
                $date = sprintf("%02d-%02d-%d", $tuple[1], $tuple[2], $tuple[3]);
                if ($date == $cdate) {
                    $chart->addPoint(new Point($date,$tuple[0]));
                    $found = True;
                    break;
                }
            }
            if (!$found) $chart->addPoint(new Point($cdate, 0));
        }
    }

    if ($days == 7) $title = _T("Evolution for last week (in pages per day)");
    elseif ($days == 31) $title = _T("Evolution for last month (in pages per day)");
    elseif ($days == 365) $title = _T("Evolution for last year (in pages per month)");
    else $title = sprintf(_T("Evolution for the %s last days"),$days);

    $chart->setLowerBound(0);
} else if ($type == "printers") {
    $printserver = $_SESSION["printserver"];
    $start = $_SESSION["dateStart"];
    $end = $_SESSION["dateEnd"];
    $limit = $_SESSION["arrayLength"];
    $data = getPrintersStats($printserver, $start, $end, "total", "ASC", $limit);

    $chart = new PieChart(600, 400);
    foreach($data as $idx => $tuple)
        $chart->addPoint(new Point($tuple[0] . ": ".$tuple[1]." pages", $tuple[1]));
    $title = _T("Distributions by printing's queues");
} else if ($type == "documentsize") {
    $printserver = $_SESSION["printserver"];
    $printer = $_GET["printer"];
    $start = $_SESSION["dateStart"];
    $end = $_SESSION["dateEnd"];
    $limit = $_SESSION["arrayLength"];
    $data = getPrinterStats($printserver, $printer, $start, $end, 1, 5, 10, 20, 50);

    $chart = new PieChart(600, 400);
    $chart->addPoint(new Point(_T("1 to 5 pages: ").$data[0][0], $data[0][0]));
    $chart->addPoint(new Point(_T("6 to 10 pages: ").$data[0][1], $data[0][1]));
    $chart->addPoint(new Point(_T("11 to 20 pages: ").$data[0][2], $data[0][2]));
    $chart->addPoint(new Point(_T("20 to 50 pages: ").$data[0][3], $data[0][3]));
    $chart->addPoint(new Point(_T("50 pages and more: ").$data[0][4], $data[0][4]));
    $title = _T("Documents size");
} else if ($type == "byuser") {
    $printserver = $_SESSION["printserver"];
    $printer = $_GET["printer"];
    $start = $_SESSION["dateStart"];
    $end = $_SESSION["dateEnd"];
    $data = getUsersStatsForPrinter($printserver, $printer, $_SESSION["dateStart"], $_SESSION["dateEnd"], "total", "desc", 10);
    $chart = new PieChart(600, 400);
    foreach($data as $idx => $tuple)
        $chart->addPoint(new Point($tuple[0] . ": ".$tuple[1]." pages", $tuple[1]));
    $title = _T("Distribution by user");
} else if ($type == "users") {
    $printserver = $_SESSION["printserver"];
    $printer = $_GET["printer"];
    $start = $_SESSION["dateStart"];
    $end = $_SESSION["dateEnd"];
    $data = getUsersStats($printserver, $_SESSION["dateStart"], $_SESSION["dateEnd"], "total", "desc", 10);
    $chart = new PieChart(600, 400);
    foreach($data as $idx => $tuple)
        $chart->addPoint(new Point($tuple[0] . ": ".$tuple[1]." pages", $tuple[1]));
    $title = _T("Distribution by user");
} else if ($type == "colors") {
    $nbBW = 0;
    $printserver = $_SESSION["printserver"];
    $start = $_SESSION["dateStart"];
    $end = $_SESSION["dateEnd"];
    $data = getColors($printserver, $start, $end);

    $chart = new VerticalChart(350, 300);
    foreach($data as $idx => $tuple) {
        if($tuple[0]==2){
            $nbColor = $tuple[1];
        }
        else {
            $nbBW = $nbBW + $tuple[1];
        }
    }
    $chart->addPoint(new Point(_T("Color"), $nbColor));
    $chart->addPoint(new Point(_T("B&W"), $nbBW));
    $chart->setLowerBound(0);
    $title = _T("Distribution color-b&w");
}

if (isset($chart)) {
    $chart->setTitle($title);
    header("Content-type: image/png");
    $chart->render();
}

exit;

?>